#include <linux/soundcard.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdlib.h>
#include <assert.h>

#define DSP_DEVICE "/dev/dsp"

enum sample_format_t{ s8, s16 };

class dsp_t {
private:
    int fd;
    int frag_size_in_bytes;
    void *frag_buffer;
public:
    dsp_t();
    ~dsp_t();
    void open_device_for_read();
    void open_device_for_write();
    void close_device();
    void set_sample_format( enum sample_format_t sample_format );
    void set_sample_rate( int sample_rate );
    void set_num_channels( int num_channels );
    void set_frag_size( unsigned short two_to_the );
    bool is_ready_for_play_buffer();
    void *get_play_buffer();
    void send_play_buffer();
    bool is_ready_to_give_record_buffer();
    void *get_record_buffer();
    void read_buf( void *outbuf, int num_bytes );
    int get_frag_size_in_bytes() { return( frag_size_in_bytes ); }
};
