
#include <stdio.h>
#include <limits.h>
#include <unistd.h>
#include "dsp_linux.h"

#define LOG_2_FRAG_SIZE 7
#define SAMPLE_RATE 8000

int main( int argc, char **argv )
{
    dsp_t dsp;
    int i;
    int best, count;

    dsp.open_device_for_read();
    dsp.set_sample_format( s8 );
    dsp.set_sample_rate( SAMPLE_RATE );
    dsp.set_num_channels( 2 );
    dsp.set_frag_size( LOG_2_FRAG_SIZE );

/*
    if( !oss_read_open( 16, 48000, 2 ) ) {
        fprintf( stderr, "volcheck: can't open oss input.\n" );
        return 1;
    }
*/
    fprintf( stdout, "|" );
    for( i =  0; i < 35; i++ ) fprintf( stdout, " " );
    for( i = 35; i < 56; i++ ) fprintf( stdout, "*" );
    for( i = 56; i < 63; i++ ) fprintf( stdout, "!" );
    for( i = 63; i < 70; i++ ) fprintf( stdout, "?" );
    fprintf( stdout, "|\n" );
    best = 0;
    count = 200;
    for(;;) {
        int min = INT_MAX;
        int max = 0;
        int left, right, bpos;
        char *buf = (char *) dsp.get_record_buffer();

        for( i = 0; i < dsp.get_frag_size_in_bytes() / 2; i++ ) {
            int cur = 128 - abs( buf[ i ] );
            if( cur < min ) min = cur;
            if( cur > max ) max = cur;
        }
        count--;
        if( max > best || count < 0 ) { best = max; count = 200; }

        left  = (int) ( ( (double)  min / 128.0 ) * 70.0 );
        right = (int) ( ( (double)  max / 128.0 ) * 70.0 );
        bpos  = (int) ( ( (double) best / 128.0 ) * 70.0 );
        fprintf( stdout, "|" );
        for( i = 0; i < left; i++ ) fprintf( stdout, "-" );
        for( i = left; i < right; i++ ) fprintf( stdout, "=" );
        for( i = right; i < bpos; i++ ) fprintf( stdout, " " );
        for( i = bpos; i < bpos + 1; i++ ) fprintf( stdout, "*" );
        for( i = bpos + 1; i < 70; i++ ) fprintf( stdout, " " );
        fprintf( stdout, "|\r" );
    }
    return 0;
}

