/**
 * Copyright (C) 2001 Billy Biggs <vektor@dumbterm.net>.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef OSSOUTPUT_H_INCLUDED
#define OSSOUTPUT_H_INCLUDED

/**
 * Open the audio device with the given bits, sample rate, and number of
 * channels.
 */
int oss_read_open( int bits, int rate, int channels );

/**
 * Closes the audio device.
 */
void oss_read_close( void );

/**
 * Plays the given buffer of the given size.
 */
size_t oss_read_fragment( unsigned char *samples, int size, int *fragnum );

int oss_read_ready( void );

#endif /* OSSOUTPUT_H_INCLUDED */
